Changes 6.1.8   Public release: upgrade to latest HDRL version, tweaks for PIPE-9871, PIPE-9969 (Archive keyword updates in some static calibration headers)
Changes 6.1.7   Paranal release: PIPE-9896/-9871/-9825/-9659/-9545/-9534/-9476, Reflect new FTP server in documentation, Fix several broken links/URLs in documentation
Changes 6.1.6   Upgrade to CPL; Fix bugs in 2D uves_obs_scired extraction; Several documentation and interactive Python GUI improvements
Changes 6.1.4   Fixed PIPE-9094: FLAMES-UVES reflex data reduction seg fault on MacOS HighSierra 10.13.6 (with clang)
Changes 6.1.3   Update tutorials and manual for Reflex 2.11; update code, OCA rules and workflow XML to reflect removed static calibrations; move old standard star info into optional static calibrations to improve response determination; use HDRL to generate response curves
Changes 6.1.2   Updated recipe man page, aligned response file naming convention with PRO.CATG, updated user manual
Changes 6.1.1   Proposed new Paranal release, to fix PIPE-8951:  (missing) PRO keywords mssing for INSTR_RESPONSE_FINE_<chip>
Changes 6.1.0   Proposed new Paranal release, to fix PIPE-8969:  uves_obs_scired does not apply extinction correction 
Changes 6.0.0   Paranal release
Changes 5.10.18 17/12/2019 Updated atmospheric exctinction table to Angstroms to easily solve PIPE-8829
                           "change fit_wrange from 4nm to 1 nm to fix problem with response fit near edges wave range" uves/uves_response_impl.c

Changes 5.10.18 10/12/2019 Updated Reflex workflow and demo data (input from Sabine); switch off telluric correction; switch off wave shift correction for 346 setting; fixed typo in computation of airmass mean
Changes 5.10.17 04/12/2019 Several bug fixes related to response determination and flux calibration
Changes 5.10.16 24/10/2019 Latest fixes to make work HDRL based response and flux calibration
Changes 5.10.15 21/10/2019 Fixed bug in noise computation
Changes 5.10.14 02/07/2019 Changes to address PIPE-8398
Changes 5.10.13 26/06/2019 Replace FPN with PD for Pattern Noise detection
Changes 5.10.12 07/06/2019 FPN mask has now only one extension
Changes 5.10.11 06/05/2019 Fixed FITS header of FPN products
Changes 5.10.10 29/04/2019 Added param to control FPN computation
Changes 5.10.9 27/04/2019  Version for QC (fixed PIPE-7979)
Changes 5.10.5 18/11/2019  Updated for py3 support
Changes 5.10.4 29/04/2019  Updated uves_wkf.oca to fix PIPE-8382
Changes 5.10.3 25/04/2019  Updated version to have proper manual update
Changes 5.10.2 17/04/2019  Version for Public release (fixed PIPE-8395)
Changes 5.10.1 15/04/2019  Final version for Public release (fixed PIPE-8247)
Changes 5.10.0 11/03/2019  Final version for PSO release
Changes 5.10.0b1 07/02/2019  Candidate version for PSO release
Changes 5.9.1 21/04/2018  Final release for Public: fixed problem run time on macOS10.13 replacing fits_open_file with ffopen in flames_midas_def.c
Changes 5.9.0 06/03/2018  Final release for Paranal, QC   for DFS2018
Changes 5.9.0b6 06/03/2018 Candidate relese for Paranal 2018, Lars fixed irplib unit tests problems
Changes 5.9.0b5 05/03/2018 Candidate relese for Paranal 2018, fix of DFS-12378
Changes 5.9.0b4 12/02/2017 Candidate relese for Paranal 2018, add location of extra calibDB for non standard settings
Changes 5.9.0b3 06/02/2017 Candidate relese for Paranal 2018, fix PIPE-7645
Changes 5.9.0b2 01/02/2017 Candidate relese for Paranal 2018, fix PIPE-7449
Changes 5.9.0b1 18/12/2017 Candidate relese for Paranal 2018, fix PIPE-7449
Changes 5.9.0b1 15/12/2017 Candidate relese for Paranal 2018
Changes 5.8.5 12/12/2017 Updated id to test Paranal 2018
Changes 5.8.4 05/12/2017 Updated id to fix oca rules problems with esoreflex-2.9.0 and PIPE-7161
Changes 5.8.3 09/04/2017 Updated id Reflex to add $ sign on FITS_VIEWER to fix product explorer behaviour
Changes 5.8.2 20/04/2017 Updated id Reflex top level layout id and doc as found 5.8.1 tag was already done before 5.8.1b
Changes 5.8.1 14/04/2017 updated version id in preparation for public release
5.8.1 updated version id in preparation for public release
13/03/2017 Fix PIPE-7120 (UVES Reflex python scripts are not compatible with astropy)
Changes 5.8.0 23/02/2017 Re-tag to fix pictures
Changes 5.7.6 13/02/2017 Re-tag to fix problems with April2017 and uves.properties file
Changes 5.7.5 12/02/2017 Re-tag to test April2017 release (proper gasgano dirs and added release notes)
Changes 5.7.4 10/02/2017 Re-tag to test April2017 release (fixed problem with CEXT)
Changes 5.7.3 08/02/2017 Re-tag to test April2017 release
Changes 5.7.2 05/01/2017 Use common m4macros
Changes 5.7.1 24/08/2016 Fixed some problem running uves-fibre (flames_prep_sff_ofpos) workflow on ubuntu, due to too short string length (161)
Changes 5.7.0 03/03/2016 Candidate release for April 2016 (with fix of PIPE-6495)
Changes 5.6.0 15/02/2016 Candidate release for April 2016 (with cleaned documentation)
Changes 5.6.0b1 14/01/2016 Candidate release for April 2016
Changes 5.5.8 02/10/2015 Changes to fix PIPE-6221 (Use of RecipeFailureMode global param in reflex),PIPE-6222 (Reflex Lazy model in DO)
Changes 5.5.7 14/09/2015 Changes to fix DFS-11239 (reflex product Explorer)
Changes 5.5.6 10/09/2015
"changed status of EnableProductExplorerMode to triggered" uves-fibre.xml.in uves.xml.in
Changes 5.5.5 05/08/2015
        Public release
Changes 5.5.5b3 04/08/2015
        Fixed typo ID workflows
Changes 5.5.5b2 17/07/2015
Updated to reflex 2.8b5
Fixed pipe 4687,5875
Updated to reflex 2.8b4
Fixed PIPE-5994 (typo in man page flames_obs_scired and flames_cal_prep_sff_ofpos)
Changes 5.5.4 22/05/2015
      Updated to reflex 2.8
Changes 5.5.3
      Fixed PIPE-5907
Changes 5.5.2
      Public release
      Changed uves_plot_common.py to deal with plotting problems on MacOS (rduces the number of plot resolution points)
      Changes to make more robust UVES-echelle data reduction with new FITS format data if 
      TM-START,DATE-OBS,EXPTIME are present both in primary header and extention
Changes 5.5.1
      Changes to fix problems ofpos
Changes 5.5.0
      PSO release
Changes 5.4.8
      Fixed crush gasgano (PIPE-5779)
Changes 5.4.7
      Removed NR
Changes 5.4.6
      Fixed PIPE-5730
Changes 5.4.5
      Fixed PIPE-5514 (changed clean_traps default in bias and mkmaster recipes to FALSE)
      Fixed PIPE-5659
Changes 5.4.4
      fixed PIPE-5512: now master bias is optional input of orderdef reflex actor
      fixed PIPE-5576
      Removed compiler warnings on deprecated functions (cpl_frameset_get_first/next)
      added note on how to generate 2D extracted frames with Reflex  in reflex tutorial
      Fixed problem generation 0 flux spectrum if reflex fiber mode
      Fixed PIPE-4795
      Fixed PIPE-3915
      Added TUNITi to tables (PIPE-3918)
Changes 5.4.3
      Just renamed 5.4.3
Changes 5.4.2
      Added creation of error associated to wavelength calibrated extracted frame to final products (PIPE-5090)
      Added support for 2D extracted frame generation and deployment in reflex_end_products directory in Reflex
Changes 5.4.1
      Fixed problem Mac OS X 10.9.2 due to incorred infdef inline in uves_util.h
Changes 5.4.0
      Removed use of has_key in python scripts for Reflex
Changes 5.3.9
      Updated (candidate release)
Changes 5.3.8
      Added interactivity to Fibre Order Detection Reflex actor
Changes 5.3.7
       Added info about target ID in reflex
       Fixed some prb report from OLE
Changes 5.3.5
       Changed reflex workflow top level layout
       Changed interactive woerkflows to have radio buttons
Changes 5.3.4
       Updated python scripts to Reflex 2.6
Changes 5.3.3
       save_flat_size in flames_cal_prep_sff_ofpos is defined "-1" that means automatic setting: 520 uses 0, else uses 2. 
       If user set a value  on command line that is taken

Changes 5.3.2
       In workflow renamed DataSelectionMethod-->SelectionDatasetMethod, RAWDATA_DIR-->RAW_DATA_DIR
       Removed re-setting of OBJECT key
       fixed typo BUNIT (A-->Angstrom)
Changes 5.3.1
       Removed different implementations depending on CPL_VERSION_CODE
       Fixed error on master bias noise computation (not robust to outliers) PIPE-4867
Changes 5.3.0
       Updated release id to planned final
       Changed keys to display in data set chooser for FIBER mode
Changes 5.2.8
       Removed Data Filter from workflow
        "fixed PIPE-4752 proper value of QC WIN1 NLINDET NITERS" uves_wavecal_search.c
Changes on 5.2.7 fixed PSL oca rules for FIBER mode 
Changes on 5.2.6 Upgrade to Reflex 2.5 
Changes on 5.2.5 
        Fix some typos on uves workflow (FLAT_min_number, BIAS_min_number)
        Fix a problem on OCA rules related to reduction of EXTEND sources
        Add products of EXTEND sources to final product dir
Changes on 5.2.4 
          "set med_dx, med_dy to proper values to have at least a model iteration on both chips (PIPE-4666)" uves_physmod_body.c
          Updated 520 param defaults for UvesFibre
Changes on 5.2.3 
    Changes flames_get_flat_size.c to make more robust offset determination in case safe_flat_size sis < 2
Changes on 5.2.2 
     "check that denominator is not too small (check its square value versus the smallest double) to fix a problem on some dat processed by reinhard on 64 bit (PIPE-4564)" uves_extract.c

     Add FIB ID info in data set chooser (PIPE-4545). Change defaults 520 Reflex.
Changes on 5.2.1 
     Fixed PIPE-4564 (portability to 64 bit of UVES pipeline): A NAN was produced using compiler option -mfpmath=387
Changes on 5.2.0 
      Adjusted flames_plot_common.py to limit flames-uves plot clutter in wavecal and scired
      Reduced mem leaks
      Uniformed reflex description from UVES user manual to tutorial one
Changes on 5.1.11
      Added workflow for FIBER mode 520
      Changed defaults to clean temporary products in flames workflow
Changes on 5.1.10
      Updated tooltips in interactive windows
      "updated with less points as defined by Sabine" xsh_response_fit_waves_cat_vis.fits
      "changed WAVELENGTH to AWAV to be FITS compliant" uves_merge.c
      "added ctype1,2 to wavemap header to be FITS compliant" uves_reduce_scired.c
      "removed some constraints in flat associated to wavecal to fix PIPE-4002" uves_wkf.oca
      "removed some constraints in flat associated to wavecal to fix PIPE-4002" uves_wkf_onlydflats.oca

Changes on 5.1.9 
      Cosmetics workflow
Changes on 5.1.8 
      Minor typos reflex display on processing data set
      Fixed invalid read size (due to typo reading size of table)
Changes on 5.1.7 
      Fixed numbering of out of data set in workflow
Changes on 5.1.6 
       Some speed-up (moving small functions to header to allow compiler to inline them)
       Updated python to reflex 2.4
Changes on 5.1.5 
       For QC clean of temporary products in ofpos and scired FIBER mode is off
Changes on 5.1.4 
       Added possibility to clean temporary products in ofpos and scired
       Dropped params output_fmt_cube, input_fmt_cube from flames_obs_scired
       Updated Initialise Data Set in wkf
       Fixed some compiler warnings
Changes on 5.1.3 
       Safer determination of order slope better working in fibre setting 860
Changes on 5.1.2 
       Fixed hole problem for extracted FIBER frames 
       Added UVES-FIBRE wkf for testing purposes" 
Changes on 5.1.1 
       Added (OCA,wkf,python) support for reduction of EXTND and SLICER data
Changes on 5.1.0 
       Fixed possible seg fault on FIBER mode (if degreeX*Y of poly order is above 32)
       Fixed several typos in FLAMES-UVES user manual
       Retagged (cleaner id)
Changes on 5.0.21
       Removed UvesFibre entries
Changes on 5.0.20
               Updated UvesFibre wkf and python scripts to reflex 2.2
                Added UvesFibre wkf for testing
                 "fixed typo in INF.FIBSTART/INF.FIBEND keywords" flames_utils_science.c
                 "changed default minthresh for FIBER mode back to its original value: 0.2 that shows to be more robust" uves_orderpos_body.c

Changes on 5.0.19
       Changes from Armin to link to include libqfits and build it as static library
Changes on 5.0.18
       Changes from Julian Taylor to ensure portability to 64 bit
Changes on 5.0.17
       In case of SimCal data force the SimCal fibre to be on on all frame
Changes on 5.0.16
       Support of FIBER mode data reduction in case of broken fibre
       "added param ozpoz takble to deal with possibly missing fibre in flames_dfs_write_descr()" flames_dfs.h
       "changed to support possibly broken fibres" flames_dfs.c
       "added param ozpoz takble to deal with possibly missing fibre in flames_crea_bp_ima" flames_crea_bp_ima.h
       "added param ozpoz takble to deal with possibly missing fibre in flames_crea_bp_ima" flames_crea_bp_ima.c
       "changed to support data reduction in case of broken fibre" flames_cal_prep_sff_ofpos_impl.c
       "changed to support data reduction in case of broken fibre" flames_obs_scired_impl.c
       "changed to support data reduction in case of broken fibre" flames_utils_science.c
       "added flames_spectra_to_image_check(),flames_images_to_cube_check()" flames_utils_science.h
       "added flames_fibremask-test.c flames_set_fibremask_from_file-test.c" Makefile.am
       "added to CVS" flames_fibremask-test.c flames_set_fibremask_from_file-test.c
Changes on 5.0.15 Reflex 2.2 release
Changes on 5.0.14 Reflex 2.2 release preparation
Changes on 5.0.13 Removed cleaning of tmp products in flames_obs_scired and flames_cal_prep_sff_ofpos
Changes on 5.0.12 Fixed some problems with interactive windows flames_obs_scired
Changes on 5.0.11 Some change from Sabine on wkf, clean some tmp product not needed in wkf on ofpos and sci flames recipes, put back flames-uves related stuff for reflex testing
Changes on 5.0.10 Some cleaning on FLAMES-UVES wkf                                                                
Changes on 5.0.9 Public release                                                                
Changes on 5.0.8 added oca, wkf, py scripts to support FIBER mode data reduction
Changes on 5.0.7 "added INS.MODE FITS key value in matching criteria of master inputs frames on relevant recipes/inputs" uves_wkf.oca uves_wkf_onlydflats.oca
Changes on 5.0.6 Updated of CPL/esorex
Changes on 5.0.5 Candidate pub release (cosmetics on wkf)
Changes on 5.0.4 Rephrase help of order_threshold (DFS09756)
Changes on 5.0.3 Further improvements of workflow
Changes on 5.0.2 Further improvements of workflow
Changes on 5.0.1 Further improvements of workflow
Changes in 5.0.0 Further improvements of workflow                         
Changes in 4.9.15  Small changes in oca rules for UVES-reflex beta reflex a5
Changes in 4.9.14  UVES-reflex beta reflex a5
Changes in 4.9.13  UVES-reflex beta
Changes in 4.9.12 Update wkf to Reflex2
Changes in 4.9.11
Changes in 4.9.10
              Update to CPL6
Changes in 4.9.9
               Removed detmon from irplib
Changes in 4.9.8
               Pub release
Changes in 4.9.7
               Changed default minthresh to 0.01 for flames_cal_orderpos
               Fixed DFS10161
Changes in 4.9.6
                Fixed DFS10228
Changes in 4.9.5

                 "fixed typo QC key  in comment" uves_reduce_scired.c
                 "fixed typo QC key  in comments"  uves_wavecal_body.c
                 "fixed typo QC key  in comments"  uves_wavecal_identify.c

Changes in 4.9.4
                 "added accuracy keywords description" uves_obs_scired_io.tex
                 "changed comments and QC accuracy as indicated by Daniel Bramich" uves_wavecal_body.c
                 "applied changes asked by Daniel Bramich on keywords specifying wave accuracy" uves_reduce_scired.c
                 "updated" cpl.version esorex.version 
                 "updated" install_uves_reflex
Changes in 4.9.3
                 "added accuracy keywords description" uves_obs_scired_io.tex
                 "changed comments and QC accuracy as indicated by Daniel Bramich" uves_wavecal_body.c
                 "applied changes asked by Daniel Bramich on keywords specifying wave accuracy" uves_reduce_scired.c

                 Uniformed QC naming conventions and clarified their comments
Changes in 4.9.2
                 added FIB_ODEF_TABLE_REDL/U and SLIT_FF_DTC_REDL/U to uves.pkd to have QC of flames_cal_prep_sff_ofpos
                 "changed uves_wavecal_search() API to allow QC log" uves_wavecal_search.h
                 "added QC to better characterize wave accuracy" uves_wavecal_body.c
                 "changed uves_wavecal_search() API to allow QC log" uves_wavecal_identify.h
                 "added QC to better characterize wave accuracy" uves_wavecal_search.c
                 "added QC to better characterize wave accuracy" uves_wavecal_identify.c

Changes in 4.9.1  Pkd support, added info on trace for DFS10007          
Changes in 4.9.0  Reflex public release
Changes in 4.8.14
           Changes in wkf layout
Changes in 4.8.13
           fixed error computing QC with uves_cal_mkmaster (DFS09854)
           Fixed flames_cal_ofpos problem with CPL5.3
Changes in 4.8.12
           Fixed some problem with dflat wkf
           Fixed compiler warnings
           adjust reference order and scaling factor in algorithm for merging of flat and dflat
Changes in 4.8.11
           Updated wkf to support dflats
           Clearer error messages using uves_cal_mflat_combine
           Added support RED arm data in uves_cal_mflat_combine
Changes in 4.8.10
           Fixed mem leaks on uves_cal_orderpos, uves_cal_response, 
                 uves_obs_scired, uves_obs_redchain
           Changed wkf layout. Fixed DFS09751, DFS09715, DFS09750
Changes in 4.8.9
           Fixed seg fault uves_obs_scired in case 
                reduce.extract.method=linear/average
           Added uves_mflat_combine
Changes in 4.8.8
           Added blemish detection
           Use blemish info to update weights and fix false CRH detection
Changes in 4.8.7
           Added wave map product to uves_obs_scired and uves_obs_redchain
           Working on BNOISE DNOISE contributes in scired
Changes in 4.8.6
           Fixed errorbar bin dependency problem (DFS08987)
           Corrected CRH map generation: now includes CRHs detected in first 
           iteration (when errorbar estimation is not yet accurate).
           Added uves_utl_dflat
Changes in 4.8.5
           Fixed workflows problems
Changes in 4.8.4
           Updated workflow python scripts
           Understood that problem on saving some FITS product on RED wkf 
           testing is due to improper OBS.TARG.NAME key value in the 
           science raw data not to a pipe problem.
Changes in 4.8.3
           Updated workflow python scripts
Changes in 4.8.2
           Fixed mflat computation using explevel method (DFS09385)
           Fixed mdark subtraction (DFS09386)
Changes in 4.8.1
           Fixed compiler warnings
           Added bias/dark noise contribute to science spectrum
Changes in 4.8.0
           QFITS first partially removed then put back as found NRI test i
           failing on  FIBER-MODE (with midas based calibs) data


           Initial ipartial removal QFITS
Changes in 4.7.9
                "fixed problem computing QC.RON.OUTi.RAW (DFS09268)" uves_mbias_impl.c
                 "moved declaration product_filename variable up to eventually used to dump an extra QC product" uves_physmod_body.c
Changes in 4.7.8
                Reflex release
Changes in 4.7.7
Changes in 4.7.6

Changes in 4.7.5
           Minor modification on user manual to:
           refrase recomendation on LINE REFER table usage (uves_ancdata.tex)
           add suggestion on tolerance value to be used (uves_cal_wavecal_io.tex)
           added tips on science data reduction (parameter section) (uves_obs_scired_io.tex) 
           added suggestion to use param defaults for standard data reductio (nuves_recipes_io.tex)

Changes in 4.7.1
           Updated Reflex part to deal with OCA frame association
Changes in 4.7.0
                 "added bias (stack) and qcdark parameters in input params to fix problem reported by NRI" uves_cal_mkmaster_impl.c
                 "add uves_qcdark_define_parameters_body(), uves_mdark_define_qc_parameters()" uves_mdark_impl.h
                 "add uves_qcdark_define_parameters_body(), uves_mdark_define_qc_parameters()" uves_mdark_impl.c
                 "rename method to stack_method" uves_parameters.c
                 "rename method to stack_method" uves_mbias_impl.c

       Disactivated blaze correction in science data reduction
       Fixed bug uves_cal_orderpos in case use_order_guess=2 (if order table start at rel order 2)
       Added QC product on uves_cal_wavecal if nwindows=1
Changes in 4.6.0
        offset param for wavecal now ranges [-25,25]

        Corrected units of response table product

        Added units in reduced science product

        changed extract.best from false to true also in uves_cal_response

        Changed PRO.CATG of reduced science to RED_NOAPPEND_...in case 
        extraction method is 'noappend'
      
        added units to guess line and order tables

        "set wavestep as parameter with range, min allowed is -1, max allowed is 0.4" uves_rebin.c (affects wavecal). 

        Added clear message in case of failing wavecalibration due to too large wavestep (not enough bins to sample a Gaussian).

        Allowed negative values of kappa (but greater than -1) to match doc.

        Subtract constant bias level from each bias before computing statistics on bias to clip outliers.

        Fixed bugs in uves_cal_predict in generation of line table

Changes in 4.5.7
        Changed pipeline install directory structure

        Added  table order_extract_qc_chip (ORDER_EXTRACT_QC_CHIP) to store QC params 
        on extraction. Renamed its column to clearer values.

        Additional method to refine flat-normalize creation
	
        Clearer error messages in case xsh_predict fails
	
	change kappa default Used for kappa-sigma clipping of the final 
	polynomial fit. in xsh_cal_orderpos from 6 to 4.
	
	Clearer error message in case of small kappa values if 1d poly
	regression fails (suggesting the user to increase kappa)
        
        Increased mbox_x/y min value to 10 to increase uves_cal_predict recipe robustness.

        Increased backsubgrid min value to 10 to increase uves_obs_orderpos recipe robustness.

        added min/max to khigh/klow/niter parameters of kappa-sigma-clip 
Changes in 4.5.6
	
	
Changes in 4.5.5
        Reflex wkf updates
Changes in 4.5.4
        Fixed seg fault for uves_create_stack_normalized_flat
        Updated Reflex wkf
        uves_cal_mkmaster_impl: added call to master creation with stak params to 
        fix NRI problem
Changes in 4.5.3
        uves_cal_mbias, uves_cal_mdark have now parameters and code to allow 
        master computation as clean mean and not only as median
Changes in 4.5.2
         Updated wkf
         Clarification on the user manual: mainly recipe i/o 9optiona, recommended input) 
         English revision from Danel Bramich
         now model_prediction prediction table is generated only in debug mode
Changes in 4.5.1
         Some bug fixes on noise computation from Reflex review
Changes in 4.5.0
                 "replace cpl_image_filter_median/linear by uves_image_filter_median/linear" uves_remove_crh_single.c
                 "added uves_image_filter_linear uves_image_filter_median" uves_utils_wrappers.h uves_utils_wrappers.c
                 "added test_load_3dtable" uves_response-test.c

Changes in 4.4.9
	Changes in QFITS to ensure portability to 64 bit platform (removed assembler code)
        Changed IRPLIB_PLOTTER to CPL_PLOTTER to make work plotting as indicated in help
Changes in 4.4.8
        Added location of traps for new red ccd
Changes in 4.4.7
        Added support of non standard waves for standard bin settings
        Fixed bug in lingain
Changes in 4.4.6
        Add proper offsets for new CCD for ECHELLE non startdard binnings (1x2 2x3)
Changes in 4.4.4
        Added support for Echellle standard settings of new CCD 
        (1x1,2x2-520-564-580-600-760-860)
Changes in 4.4.3
        fixed bugs in setting ECH_ANG_OFF, CD_ANG_OFF,CCD_ANG_OFF in 
        uves_physmod_create_table.c
        Fixed bug in setting 
Changes in 4.4.2
        Fixed DFS06601 (changed way to set trans_x/y and removed offet of 6.7 pix on REDU chip)
Changes in 4.4.0
        Upgrade to CPl5.0
Changes in 4.3.0
        Fixed compiler warnings
Changes in 4.2.9
        Fixed bug in setting delt1/2 parameters. Updated their man page.
        Set a corresponding proper range.
Changes in 4.2.8
        Removes xxx_ functions (originally used in place of cpl_table)
        fixed DFS05803 (seg fault due to missing check on array boundary)
Changes in 4.2.7
        Fixed some problems from NRI and recipe unit tests
Changes in 4.2.6
	Fixed mem leaks
Changes in 4.2.5
        Add back uves_cal_lingain, uves_cal_ronbias
        Changed uves_cal_ronbias to reflect detmon function API change
        Added recipes/tests
Changes in 4.2.4
        Fixed robustness problem corvel computation. (5110)
        Fixed robustness problem (DFS5458)
Changes in 4.2.3
        Added merge_delt1,merge_delt2 parameters to allow to chop off some of the overlapping in the frame merging
        Fixed problem misalignment order-line guess tables on single fiber frames
        Now user can set trans_x/y also in fiber pmode to correct physical model        predictions
Changes in 4.2.2
        DFS05346 Problem wavecal/merge: absorption lines may appear as doublets
        in merged spectra. Solved by decreasing wavecal poly degree default 
        to 4.

Changes in 4.2.1
        Added uves_cal_ronbias
        DFS05302 Added PRO.REC1 keys in uves_cal_prep_sff_ofpos products
        DFS05106 Now header of slit_ff_products is the one of the 1st frame of the input sof
        DFS05102 Implemented flames_utl_decubify
Changes in 4.2.0
        DFS05140: changed LF.DO.CATG in DO.CATG for CD_ALIGN_RED to uniform to CD_ALIGN_BLUE. 
        DFS05139: Updated gasgano rule files to support classifification of
        input raw data for uves_cal_lingain recipe
        Added products of uves_cal_lingain to oca rules.
Changes in 4.1.0
        Removed uves_cal_ccdtest from oca file
        Added flames_cal_mkmaster in UVES.prefs
        Disables uves_cal_ronbias
        Updated cpl.version and esorex.version dependency IDs
Changes in 4.0.0
        As 3.5.7 but updated release ID for PSO release (as includes fiber mode)
Changes in 3.5.7
        Added parameter clean_traps (shared in uves_obs_scired and 
        uves_cal_mbias) to control the detector's trap corrections
Changes in 3.5.6
        DFS05042: Fixed wrong INFO in FIB_FF_*_INFO_TAB
        Fixed DFS04897: Failure to trace first fibre of FFLAT
        added parameter save_flat_size to flames_cal_prep_sff_ofpos to control
        SFLAT flat size measure
        Fixed DFS05026: Missing PIPEFILE in fibreff cube products.
        
Changes in 3.5.5
        Made uves_cal_lingain products arm dependent (note that in case of RED data results are in separate estentions).
        DFS03207: Poor fibre identification in Fibre Flats. This problem has been fixed
        improving robustness of the function to measure the MSFLAT FWHM and YSHIFT
        In flames_cal_prep_sff_ofpos added parameter to control on which chip is performed the data reduction.
        DFS05006: Added parameter to allow clean of trap columns in science 
        frames (to improve 2D data reduction quality)
        Fixed bug loading pipe generated INSTR_RESPONSE
        Demoted assure on check_table_invalid_rows to make 
        flames_cal_prep_sff_ofpos more robust on MIDAS generated FIB_GUE_ORD_TAB
Changes in 3.5.4
        Changed order of LDFLAGS in uves/Makefile.am and flames/Makefile.am
        to make sure that libuves.so and libflames.so always find the same
        version of libqfits as each other.
Changes in 3.5.3
        More robust SFLAT size-offset determination
        Support of BLUE 625 KHz frames format with image estension.
        Improved uves_common.prg including DETMON_QC dictionary call
        Simplified uves_cal_lingain
        Cleaned some compilation warnings
Changes in 3.5.2
        Updated uves_cal_lingain to support BIAS_x and SCREEN_FLAT_x, x=BLUE,RED
        Aadded uves_cal_lingain.rrd,rri,prg
Changes in 3.5.1
        Implemented new function to compute YSHIFT and HALFWIDTH on mflats
        to solve DFS04815

Changes in 3.5.0
        Added HIERARCH ESO FIB keys in flames science packed merged frames (DFS04828)
        DFS04881: allow usage of parameter process_chip to process each chip separatelty
        Temporaly suppressed velocity correlation correction in SimCal
        Added test_flames_msffsz
Changes in 3.4.9
	Fixed DFS04829: (zero merged spectra in packed image)
	
        Added uves_cal_lingain from detmon project
	
	Lamp on frames (FLAT frames) should be tagged as ON_RAW
	
	Lamp off frames (BIAS frames) should be tagged as OFF_RAW
	
	New FITS format UVES data (after 1st April 2004) should be processed 
	using --exts=1
	
Changes in 3.4.8
        Now the stability check computes a clean median as in MIDAS
Changes in 3.4.7
        Removed flames recipes
        Added HIERARCH ESO info on debug products
        Fixed some problems with flames physical model and reduced to 1 the number of iterations.

Changes in 3.4.6
        Added flames recipes
        Fixed PRO.CATG of fxb_l_rawpack XB_SCI_RAW_REDL 
        and added ERR_MWXB_SCI_RAW_x and ERR_MWXB_SCI_x as asked by DFS04684
Changes in 3.4.5
        Fixed bug in science reduction of extended sources (DFS04679)
        Changed PRO.CATG of single fibre order table (product of flames_cal_orderpos) from 
        FIB_GUE_ORD_TAB_x to FIB_ORD_TAB_x (DFS04279)
        Added DATAMD5 to calib products of flames_obs_redchain and uves_obs_redchain (DFS04674/DFS04633)
        Added support for object weighted arclamp extraction (DFS04017)
        If provided, allows MASTER_BIAS_x subtraction from orderpos and 
        formatcheck (amd reference formatcheck) frames.
        Cleaned output

Changes in 3.4.3
        Included flames-uves recipes
	Fixed flames_uves reduction chain.
	
	Fixed the following problem reports:
        DFS04517: Put proper information on detector CHIP in UVES physical 
	model plots
	DFS04516: Fixed crash of UVES reduction chain on uves_cal_orderpos 
	step.
	DFS04513: If DATANCOM is missing in input master flat it is assumed 
	for noise computation in science reduction a default of 5.
	DFS04413: UVES & Gasgano problem
	DFS04334: wrong pipe ID in uves_common.prg
        DFS04331: Added parameter to proces a single chip
        DFS04327: Scale backsub.radiusy by the y size of the bin

Changes in 3.4.2
        More doxigen doc on flames-uves
        Fixed DFS04228: STRUCTX QC1 parameter is not written on QC-LOG 
	                (in PSO ops-log files) 
              DFS04274: Failure of uves_cal_orderpos


Changes in 3.4.1
	Fixed bug in uves_cal_mkmaster which was crashing the uves_obs_redchain
        DFS04330 Fixed flames_cal_wavecal failure
Changes in 3.4.0
	Fixed SPRs:
	DFS04308 Gasgano classification rules incomplete (SCREEN_FLAT_x)
	DFS04309 Double underscore in PRO.CATGs of FLUXCAL & FLUXCAL_ERRORBAR products
        New science products filenames are now:
	
         RED_2D_SCI_EXTND_BLUE red_2d_science_blue.fits
         EXT_2D_SCI_EXTND_BLUE  ext_2d_science_blue.fits
         MER_2D_SCI_EXTND_BLUE merged_2d_science_blue
         WCAL_2D_SCI_EXTND_BLUE resampled_ff_2d_science_blue.fits
         FF_2D_SCI_EXTND_BLUE ff_2d_science_blue.fits
         ERR_2D_SCI_EXTND_BLUE error_2d_science_blue.fits
         FLUXCAL_2D_SCI_EXTND_BLUE fluxcal_2d_science_blue.fits
         FLUXCAL_ERRORBAR_2D_SCI_EXTND_BLUE fluxcal_error_2d_science_blue.fits



         RED_SCIENCE_BLUE red_science_blue.fits
         MERGED_SCIENCE_BLUE merged_science_blue.fits
         WCALIB_SCIENCE_BLUE resampled_science_blue.fits
         WCALIB_FF_SCIENCE_BLUE resampled_ff_science_blue.fits
         WCALIB_FLAT_OBJ_BLUE resampled_mflat_science_blue.fits
         ERRORBAR_SCIENCE_BLUE error_red_science_blue.fits
         VARIANCE_SCIENCE_BLUE variance_ff_science_blue.fits
         BKG_SCI_BLUE background_blue.fits
         ORDER_TRACE_BLUE ordertrace_blue.fits
         CRMASK_BLUE cr_mask_blue.fits
         MERGED_SKY_BLUE merged_sky_blue.fits
         FLUXCAL_SCIENCE_BLUE fluxcal_science_blue.fits
         FLUXCAL_ERRORBAR_SCIENCE_BLUE fluxcal_error_science_blue.fits

         Note also that variance and error attribute is now in front of 
	 file name.

Changes in 3.3.9	
	Crush of flames_cal_prep_sff_ofpos with CPL generated MSFLATs


Changes in 3.3.8
----------------
	Fixed several SPRs:
	DFS04196: Cleanup and improvement of uves_obs_scired for 2D extraction
	          (removed double '_' in FLUXCAL & FLUXCAL_ERRORBAR products,
	           standardized naming convention of science products for 1d
	           and 2d extraction following DFO requirements).
	
	DFS04196: ERROR file missing from 2d uves_obs_scired output
	DFS04274: cpl_tools_get_cputime failure in uves_cal_ordertrace
	DFS04283: UVES average extraction fails
	


Changes in 3.3.5
----------------
	Fixed several SPRs:
	DFS04051: Mis-Order identification in uves_cal_orderpos
	DFS04175: Poor order trace in uves_cal_orderpos
	DFS04255: Order trace failure for DICH#1 564.0
	
                  uves_cal_orderpos has been modified to add use_guess_tab
	          parameter to specify how to use the input guess table:
	
--use_guess_tab : If a Guess order table is provided this parameter set
                  how it is used:0: No usage, 1: use it to set
                  lower/upper Y raws where order are searched 2: the
                  order table try to fully match the guess. [1]


	
	DFS04195: New QC1 parameters in uves_cal_dark recipes:
	          QC REGi [MIN|MAX|AVG|MED|RMS] are generated on several 
	          regions evenly distributed on the detector. Those are
	          controlled by new recipe parameters:

  --qc_dark.reg.num_x   : Number of regions on X direction (where mean/med/rms
                          are computed). [4]
  --qc_dark.reg.num_y   : Number of regions on Y direction(where mean/med/rms
                          are computed). [4]
  --qc_dark.reg.box_sx  : Region X size. [100]
  --qc_dark.reg.box_sy  : Region Y size. [100]
  --qc_dark.reg.border_x: X distance from the left hand side detector's border
                          and the left hand side regin's bottom corner. [100]
  --qc_dark.reg.border_y: Y distance from the left hand side detector's border
                          and the left hand side regin's bottom corner. [100]
  --qc_dark.reg.when    : When QC analysis is performed. 
	                  0: on each raw frame or
                          1: on the master frame. [0]	                 
	

	
      DFS04196: Some cleanup on 2D extraction PRO.CATG and default file names.
      DFS04197: Added ERROR file on 2D extraction.

      Upgrade to CPL4.
      Added unit tests.
	
	
      Completed conversion of FLAMES-UVES to CPL and started testing. This
      part is not yet delivered as part of this release.

	
Changes in 3.3.4
----------------

        uves_cal_tflat +???: Added QC parameter INS.SLITi.NAME
	
	Updated to work with both CPL-3.x and CPL-4.x
       

Changes in 3.3.3
----------------

        Added support new format FLAMES
       

Changes in 3.3.2
----------------

        uves_obs_redchain: Minor bugfix: If both raw dark and master dark
	frames are provided, the master dark is not recomputed unlike before.


Changes in 3.3.1
----------------

	(released to public)
        Fixed typo in description of the parameter --plotter


Changes in 3.3.0
----------------

        Changed wavelength calibration tolerance from 0.07 to 0.6. The
	value 0.07 was too low for some (red) wavelength settings.


Changes in 3.2.3 (public beta-release)
----------------

        Catch possibility that ORDi OBJ POS is NAN (flux_tot=0) and set it to -1
        (normally it should be >0). This could cause execution failure during
        average/linear (response/tflat recipes) if line tilt correction
        was enabled.

        Removed the recipe uves_obs_spatred which is exactly the same as
        uves_obs_scired but with the option --reduce.extract.method=2d

        All recipes: Removed parameter --midas, which was used only by
	the pipeline developers for regression testing and is no longer useful.

        All recipes: Removed parameter --imager which was not really supported
	by any recipe anyway.

        Added check in reduction that the provided master flat-field's
	mean is not zero, NaN or infinity. In this case the recipe will
	fail, rather than silently succeed.

	
Changes in 3.2.2
----------------

        uves_cal_mdark: Disabled the thresholding of negative values to
        zero after bias subtraction.


Changes in 3.2.1
----------------

        uves_cal_orderpos: Avoid the detection of very short orders near
        the chip edge top/bottom which could not be reliably traced in
        the current scheme.        

        Optimal extraction: Changed spectrum error formula to take fully
        into account sky contribution. This causes a lower but slightly
        more accurate reported S/N.


Changes in 3.2.0
----------------

        Optimal extraction: Added support for setting extraction slit
        offset and slitlength. This allows extraction of multiple sources.

        Wavelength rebinning: Automatically correct for line tilt by
        interpolating the previously obtained dispersion polynomials
        at the measured object position

        uves_obs_redchain: Implemented option (--scired=false) to produce
        all master calibration frames but skip the final science reduction

        uves_cal_wavecal: Fixed execution error in the resolution
        computation which was not robust to the unexpected situation
        where the dispersion d(lambda)/dx had the wrong sign (due to
        fitting too few lines with too many polynomial coefficients)

        uves_cal_wavecal: Fixed execution error in the resolution
        computation which was not robust against negative error bars

        uves_cal_wavecal: Added QC1 parameter ESO.QC.NLINSOL which is
        the number of lines that were actually used in the wavelength
        solution. Added column "NLinSol" to line table containing the
        value 1 (0) if the line was (was not) used to obtain the
        dispersion solution

        uves_cal_wavecal: Changed default slitlength from 15 pixels to one
        third of the value defined in the arc lamp FITS header. This is to
        support flat-field correction in which case the noisy interorder regions
        should not be extracted.
        

Changes in 3.1.1
----------------

        Wavelength calibration: If the master flat and/or master bias is
        provided, the arclamp frame will be flat-fielded and/or debiased.
        If the arclamp was flat-fielded a modified line search algorithm
        is used, which takes into account the spectrum error bars. If no
        flat-field is provided the wavelength calibration works as before.
        
        Optimal/simple extraction: If the calling recipe
        (science/response/wavecal) is run with the --debug option, an
        intermediate FITS file 'simulate.fits' is saved to the local
        directory. It contains a simulated raw image created using only
        the extracted object + sky spectra + cosmic ray locations.

        Fixed value of keyword HIERARCH.ESO.PRO.REC1.DRS.ID from
        'uves/X.Y.Z' to 'cpl-X.Y.Z' (bug introduced in 3.1.0)

        
Changes in 3.1.0
----------------
        
        Optimal extraction, virtual method: Now uses sampling factor 10 if
        the estimated S/N is > 200, otherwise 5 (as previously)

        uves_obs_scired, uves_cal_response, uves_cal_tflat:
        added QC parameter ESO.QC.ORDi.OBJ.RPLPAR to estimate
        small scale oscillation amplitude

        uves_cal_wavecal: Increased robustness of the computation of the
        mapping between relative and absolute order numbers

        uves_cal_wavecal: Implemented option to use automatic polynomial
        degrees when fitting the dispersion solution. The default degree
        is still 5.     


Changes in 3.0.2
----------------

        uves_cal_orderpos: If an order table is provided as input, the
        recipe will no longer do a Hough transform but simply detect the
        orders defined in the input table. Orders are detected using a Hough
        transform only if no input table is given.
        
        Changed value of FITS keyword CRVAL2 in REDU products from 2049
        to 2113 in order to reflect the physical gap between the two red
        CCD chips.
        
        Minor bugfix in uves_cal_orderpos when determining the optimal
        polynomial degrees which, in rare cases, could be less than fully
        optimal. Impact: probably none.

        Science recipe: Bugfix in generation of the product
        WCALIB_SCIENCE_x which was erroneously flat-fielded.
        
        
Changes in 3.0.1
----------------

        Optimal extraction: Speed-up. Fixed bug that the extracted
        spectrum might be completely wrong if the object offset is very
        close to +- 15 pixels.
        

Changes in 3.0.0
----------------

        Optimal extraction, virtual method: The spatial profile is now fitted
        with low-order polynomials as function of (x, order), where
        previous versions assumed a constant profile, for efficiency
        reasons. This was needed to have good results also at very high S/N

Changes in 0.9.10
-----------------

        Changed computation of master bias QC parameters to exactly match
        what MIDAS' STAT/IMAGE does.

Changes in 0.9.9
----------------

        uves_cal_wavecal:
        - The continuum slope is now included in the Gaussian fit to
        emmision lines.
        - Default tolerance lowered from 0.6 pixels to 0.07
        pixels for support of the new reference line catalogue.
        - When obtaining the dispersion solution, outliers are rejected
        using kappa sigma clipping.
                
        Renamed recipe uves_cal_mkmaster_tflat -> uves_cal_tflat

        Reduced the overall execution time for uves_obs_scired by a factor
        ~2 (when using the default optimal extraction, virtual method).
        

Changes in 0.9.8
----------------

        Fixed bug that uves_cal_mkmaster_tflat execution sometimes failed when
        calculating QC.ORDi.DATA(MIN|MAX|AVG|RMS|MED) for first/last order


Changes in 0.9.7
----------------

        Fixed bug introduced in v0.9.6 that the REDL chip was processed
        twice for RED arm input.

Changes in 0.9.6
----------------

        Changed CRVALi in recipe products to not include the detector
        overscan and prescan areas

        Renamed the following recipes
          uves_mbias    ->  uves_cal_mbias
          uves_mdark    ->  uves_cal_mdark
          uves_physmod  ->  uves_cal_predict
          uves_orderpos ->  uves_cal_orderpos
          uves_mflat    ->  uves_cal_mflat
          uves_wavecal  ->  uves_cal_wavecal
          uves_response ->  uves_cal_response
          uves_tflat    ->  uves_cal_mkmaster_tflat
          uves_scired   ->  uves_obs_scired
          uves_redchain ->  uves_obs_redchain
        and added four recipes
          uves_cal_cd_align       : Measures Cross Disperser positioning
          uves_cal_mkmaster       : Same as uves_cal_mbias/dark/flat
                                    depending on type of input frames
          uves_cal_mkmaster_sflat : Same as uves_cal_mflat
          uves_obs_spatred        : Same as uves_obs_scired, but the
                                    extraction method defaults to 2d.
        
        Implemented workaround for bug in cpl_image_threshold()
        (DFS03433) that caused very large sigmas to be set to only 2**31
        in the rebinning step. This decreases the probability of
        infinities showing up in the final products

        Minor bugfix in computation of QC.OUTi.RON.MASTER and
        QC.OUTi.RON.RAW (+-10% outliers were not ignored, now they are)

        
Changes in 0.9.5
----------------

        INF + NAN no longer written to FITS files.

Changes in 0.9.4
----------------

        Optimal extraction: Fixed bug in sky subtraction: the sky term was
        forgotten when looking for outlier pixels. This seems to solve the
        problem of strong sky emission lines causing residuals in the
        object spectrum. Default sky subtraction method changed to
        "optimal" which has slightly better S/N than the "median" method
        used before.

        QC-parameters: ESO.QC.ORDi.OBJ.(SN|POS|FWHM) are logged also in
        average/linear extraction mode (previously: only when using
        optimal extraction). ESO.QC.EX.(NORD|XSIZE|YSIZE) added to some
        products of uves_scired and uves_response. Bugfix in computation
        of ESO.QC.OPTEX.YSIZE which is the extraction slit, not the
        image height.
        

Changes in 0.9.3
----------------

        Master flat recipe: No longer thresholds pixel values to zero
        after bias + background subtraction
        
        Added 'Select' column to wave.cal. product line tables

        Added option to select optimal extraction sky-subtraction method
        (median/optimal, default: median) independently from profile
        measuring method

        Added FLAMES recipes (preliminary) and renamed pipeline to FLAMES/UVES

    Bugfixes:
        Fixed CDELTi, CRVALi, CRPIXi, CTYPEi keywords to self-consistently
        describe the geometry of the BLUE/RED detector arrays. The 
        information about the orientation of products wrt input frames is
        not propagated which would probably require using the CROTAi keywords
        
        Fixed a 4 byte buffer overrun in rebinning step

        Made uves_physmod run when --debug=true

        Made optimal extraction more robust for extended objects

        The QC parameters ESO.QC.ORDi.OBJ.POS and ESO.QC.ORDi.OBJ.FWHM
        were swapped. Now they are correct
        
Changes in 0.9.2
----------------

        Changed guess line table PRO CATG from LINE_TABLE_* to LINE_GUESS_TAB_*

Changes in 0.9.1
----------------

        Implemented TFLAT QC test

        Implemented barycentric/heliocentric velocity correction QC parameters

        Renamed line table columns so that they have the same
        names (WAVEC, RESIDUAL, PIXEL) as in the MIDAS pipeline

        Fixed a problem in the stability check: From now on it runs only the
        uves_msrawxy section and table comparison and not all the rest.

Changes in 0.9.0
----------------
        Implemented QC parameters (physmod: stability check,
        wavecal: intensity monitoring, scired)
        
        Updated to CPL3.0 (faster polynomial fitting, correct
        default parameters when running with Gasgano, ...)

        physical model: fixed problems in QX X/Yshift parameter discrepancies

        Fixed a problem in physmod joining table (tolerance increased)

        Fixed a bug in uves_physmod_msrawxy in table selection which 
        occasionally generated wrong ORDERMAX values

        Optimal extraction: Automatically detects profile measuring method
        based on an initial estimate of the object S/N

        Optimal extraction: S/N increased by doing a second extraction
        using improved variance estimates based on the 1st extraction

        Significantly reduced execution time for sky subtraction

        Added support for master TFLAT_ and SCREEN_FLAT_ frames

        Added support for MASTER_RESPONSE correction

        Response recipe does not fail but reduces the standard star
        when there is no matching catalogue object (DFS02900)

Changes in 0.8.5
----------------
Added QC parameters
        - orderpos:  Added DET CHIP1 NAME
                             INS GRAT1 NAME
                             INS GRAT1 WLEN
                             INS MODE
                             QC ORD RESIDRMS
        
        - wavecal: Missing  DET CHIP1 NAME
                            INS GRAT1 NAME
                            INS GRAT1 WLEN
                            INS MODE
                            INS PATH
                            INS SLIT2 WID
                            INS TEMP1 MEAN

Master Bias
 ARCFILE should log the contents of 'ARCFILE' rather than the filename.
        
Physical Model: 
normal
        Make output more understandable for the casual user.
        Add units and use less significant digits where relevant.
        
normal-     
        Update physmod to properly treat old and new UVES data  
normal
        Verify correctness of tag names on man-page.

        
done normal
        Don't #define true/false in uves_physmod_cstacen.c


done normal
        Support bad pixels in optimal extraction (to allow flat-fielding method = pixel)


Changes in 0.8.4
----------------
done normal
        Rebinning: The flux is resampled using a smooth interpolated
        profile. This reduces resampling noise.

done normal
        Find a way to make doxygen warn about functions with missing documentation

done normal
        Optimal extraction: Change sky flux normalization from 1
        pixel to full slit.

done normal - Add support of Moffat profile


done normal
        Optimal extraction: Compute table with observed profile
          prof(order, x, dy) = flux(order, x, dy) / extracted(order, x)
        (and with interpolated profile if possible)

done normal
        Test effect of no integration over bin on extraction quality

        Solution: This was tested on UVES.2000-02-12T06:06:55.689.rb which
        is a high S/N ~= 250, narrow, fwhm ~= 2-3 pixels, object, for which
        the effect of integration is expected to be biggest.
        1) MIDAS standard: small scale oscillations
        2) CPL standard (Gauss-Legendre integration over bin): no oscillations
        3) CPL no integration over bin: extremely similar to case 2). One has to
        look very carefully to notice the difference which is well below the
        inherent noise level.
        Conclusion: A lack of bin-integration does not cause the observed
        ripples, even for narrow, high S/N objects.

done low (maybe)  
        Make 'make distcheck' work      

done low (maybe)
        Make code portable to Mac
        Solution: The package is known to install and 'make check' on Mac.

Done after version 0.8.2
------------------------

Bugfixes:
- Optimal extraction halted if first/last order had no bins
completely inside the image (an introduced bug).
- Response/science recipes: Atmospheric extinction correction was randomly disabled, depending
on the contents of uninitialized memory (an introduced bug).
        
Internal/maintenance:
- Simplified uves_insert_frame (too long function)

New stuff:
done - (andrea) - Add basic routines to do QC log.
done - (andrea) - Add rules to support any recipe provided.
Done after version 0.8.1
------------------------

done normal
        Removed test data from distribution

EXTRACT

done normal
        Optimal extraction: Update the profile measurement to decrease
        sample step size until we have an appropriate number of
        (non-rejected) measure bins

done normal
        Optimal extraction: Factor out gaussian assumption.

MASTER FLAT

done normal
        Support [MASTER_]DFLAT_xxxx frames
        Support [MASTER_]IFLAT_xxxx frames

done normal
        Use different default smooth windows depending on type of input
        frame (science or flat)
        

MASTER DARK
        
done normal
        Support [MASTER_]PDARK_xxxx frames
done normal
        The recipe (MIDAS+CPL) produces negative fluxes (trans-dark?).
        Is that really what we want?
        Solution: This was caused by bias subtraction where bad columns
        was corrected (no correction in dar/flat. Now, the flux is
        thresholded to zero.


Done after version 0.8.0
------------------------

done high
        Check ~20 pixels difference in line table xdif ydif
        UVES.2000-03-12T09:51:16.834.rb
        Solution: This is likely caused by different detections by
        the 2d search/centering step. This can cause deviations up
        to 2x(search window size).


normal
        Line table column aux has type double but is always an integer value.
        (MIDAS: floating point values)
        
        
normal
        In a few cases (e.g. UVES.2000-03-12T19:24:03.552.rb) line table
        column Selplot contains garbage


Done after version 0.7.8
------------------------


GENERAL
done normal - rejected
        Remove MIDAS flags (?)
        Solution: It was decided to keep the MIDAS flags, as they do no
        harm (other than making the code slightly more complex) and they will
        probably be needed later

PHYSMOD
done normal
        Implement master format check
        
done normal
        Remove memory leaks

RESPONSE
        
done normal
        Doxygen+manpage documentation

        
SCIENCE
        
done normal
        Doxygen+manpage documentation
